<?php
// FractalMeet 1.0 
// Copyright Mikael Cromsjö 2021


//	ini_set('display_errors	', 1);
//	error_reporting(E_ALL);

	chdir ("../"); 
	include 'functions.php';


	$userId = $_POST['userId'];
	$pin = $_POST['pin'];
	$action = $_POST['action'];
	$layer = $_POST['layer'];
	$id = $_POST['id'];
	
	$Fractal = new fractal($id);
	
	$userData = $Fractal->getUserData($userId);
	$meeting = $userData->layer->{$layer}->meetingId;
	$groupId = $userData->layer->{$layer}->groupId;
	
	// If observer get rep group data
	if (!isset($groupId) && $layer > 0) {
		$prevGroupData = $Fractal->getGroupData($layer-1, $userData->layer->{$layer-1}->meetingId, $userData->layer->{$layer-1}->groupId);
		$repId = $prevGroupData->rep->id;		
		$repData = $Fractal->getUserData($repId);
		$meeting = $repData->layer->{$layer}->meetingId;
		$groupId = $repData->layer->{$layer}->groupId;	
	}
	
	$groupData = $Fractal->getGroupData($layer, $meeting, $groupId);
		
	// check pin
	if ($userData->pin != $pin) {
		return  '{"status": "failure - pin error"}';
	}
	if ($groupData->sec->id == $userId) {
		$isSec = true;
	}
	
	switch($action) {
		case "import":
			$Fractal->importContribs($layer, $meeting, $groupId, $groupData);
			echo json_encode($groupData);
			break;
			
		case "getGroupData":
			echo json_encode($groupData);
			break;
		
		case "updateStars":
			$genid = $_POST['genid'];
			$stars = $_POST['stars'];
			if ($groupData->stars->{$genid}->{$userId} != $stars) {
				$groupData->stars->{$genid}->{$userId} = $stars;
			}
			else {
				unset($groupData->stars->{$genid}->{$userId});
			}
			$Fractal->updateGroupData($layer, $meeting, $groupId, $groupData);
			
			echo json_encode($groupData);
			break;
			
		case "updateGroupData":
			if ($isSec) {
				$titles = $_POST['titles']['titles'];
				$desc = $_POST['desc']['desc'];
				$genids = $_POST['genids']['genids'];
								
				$groupData->contrib->titles = $titles;
				$groupData->contrib->desc = $desc;
				$groupData->contrib->genids = $genids;				
				
				$Fractal->updateGroupData($layer, $meeting, $groupId, $groupData);
				echo json_encode($groupData);
				break;
			}
			else { 
				echo  '{"status": "failure - not sec"}';
			}
			break;		
		case "updateSec":
			$sec = $_POST['sec'];
			// replace sec
			$users = $groupData->users;
			foreach ($users as $user) {
				if ($user->userId == $userId){
					$user->secId = $sec;
				}
				$newUsers[] = $user;
			}
			$groupData->users = $newUsers;
			$sec = $Fractal->calcSec($groupData);
//			$groupData->sec = array("id" => $sec);
			$groupData->sec = array("id" => $sec, "name" => $Fractal->getUserData($sec)->username);
			$Fractal->updateGroupData($layer, $meeting, $groupId, $groupData);
			echo json_encode($groupData);

			break;
		case "updateRep":
			$rep = $_POST['rep'];
			// replace rep
			$users = $groupData->users;
			foreach ($users as $user) {
				if ($user->userId == $userId){
					$user->repId = $rep;
				}
				$newUsers[] = $user;
			}
			$groupData->users = $newUsers;
			$rep = $Fractal->calcRep($groupData);
//				$groupData->rep = array("id" => $rep);
				$groupData->rep = array("id" => $rep, "name" => $Fractal->getUserData($rep)->username);
			$Fractal->updateGroupData($layer, $meeting, $groupId, $groupData);
			echo json_encode($groupData);

			break;
		default:
			echo '{"status": "fail"}';
			break;
	}
		
?>
